<!DOCTYPE html><html class="default" lang="en"><head><meta charSet="utf-8"/><meta http-equiv="x-ua-compatible" content="IE=edge"/><title>@matrixai/async-init</title><meta name="description" content="Documentation for @matrixai/async-init"/><meta name="viewport" content="width=device-width, initial-scale=1"/><link rel="stylesheet" href="assets/style.css"/><link rel="stylesheet" href="assets/highlight.css"/><script defer src="assets/main.js"></script><script async src="assets/search.js" id="tsd-search-script"></script></head><body><script>document.documentElement.dataset.theme = localStorage.getItem("tsd-theme") || "os"</script><header class="tsd-page-toolbar">
<div class="tsd-toolbar-contents container">
<div class="table-cell" id="tsd-search" data-base=".">
<div class="field"><label for="tsd-search-field" class="tsd-widget tsd-toolbar-icon search no-caption"><svg width="16" height="16" viewBox="0 0 16 16" fill="none"><path d="M15.7824 13.833L12.6666 10.7177C12.5259 10.5771 12.3353 10.499 12.1353 10.499H11.6259C12.4884 9.39596 13.001 8.00859 13.001 6.49937C13.001 2.90909 10.0914 0 6.50048 0C2.90959 0 0 2.90909 0 6.49937C0 10.0896 2.90959 12.9987 6.50048 12.9987C8.00996 12.9987 9.39756 12.4863 10.5008 11.6239V12.1332C10.5008 12.3332 10.5789 12.5238 10.7195 12.6644L13.8354 15.7797C14.1292 16.0734 14.6042 16.0734 14.8948 15.7797L15.7793 14.8954C16.0731 14.6017 16.0731 14.1267 15.7824 13.833ZM6.50048 10.499C4.29094 10.499 2.50018 8.71165 2.50018 6.49937C2.50018 4.29021 4.28781 2.49976 6.50048 2.49976C8.71001 2.49976 10.5008 4.28708 10.5008 6.49937C10.5008 8.70852 8.71314 10.499 6.50048 10.499Z" fill="var(--color-text)"></path></svg></label><input type="text" id="tsd-search-field" aria-label="Search"/></div>
<div class="field">
<div id="tsd-toolbar-links"></div></div>
<ul class="results">
<li class="state loading">Preparing search index...</li>
<li class="state failure">The search index is not available</li></ul><a href="index.html" class="title">@matrixai/async-init</a></div>
<div class="table-cell" id="tsd-widgets"><a href="#" class="tsd-widget tsd-toolbar-icon menu no-caption" data-toggle="menu" aria-label="Menu"><svg width="16" height="16" viewBox="0 0 16 16" fill="none"><rect x="1" y="3" width="14" height="2" fill="var(--color-text)"></rect><rect x="1" y="7" width="14" height="2" fill="var(--color-text)"></rect><rect x="1" y="11" width="14" height="2" fill="var(--color-text)"></rect></svg></a></div></div></header>
<div class="container container-main">
<div class="col-content">
<div class="tsd-page-title">
<h2>@matrixai/async-init</h2></div>
<div class="tsd-panel tsd-typography"><a id="md:js-async-init" class="tsd-anchor"></a><h1><a href="#md:js-async-init">js-async-init</a></h1><p>staging:<a href="https://gitlab.com/MatrixAI/open-source/js-async-init/commits/staging"><img src="https://gitlab.com/MatrixAI/open-source/js-async-init/badges/staging/pipeline.svg" alt="pipeline status"></a>
master:<a href="https://gitlab.com/MatrixAI/open-source/js-async-init/commits/master"><img src="https://gitlab.com/MatrixAI/open-source/js-async-init/badges/master/pipeline.svg" alt="pipeline status"></a></p>
<p>Asynchronous initialization and deinitialization decorators for JavaScript/TypeScript applications.</p>
<p>Because decorators are experimental, you must enable: <code>&quot;experimentalDecorators&quot;: true</code> in your <code>tsconfig.json</code> to use this library.</p>
<p>TypeScript does not allow decorator properties that are protected or private.</p>
<p>Example Usage:</p>
<pre><code class="language-ts"><span class="hl-0">import</span><span class="hl-1"> { </span><span class="hl-2">CreateDestroyStartStop</span><span class="hl-1">, </span><span class="hl-2">ready</span><span class="hl-1"> } </span><span class="hl-0">from</span><span class="hl-1"> </span><span class="hl-3">&#39;@matrixai/async-init/dist/CreateDestroyStartStop&#39;</span><span class="hl-1">;</span><br/><br/><span class="hl-4">// this hack is necessary to ensure that X&#39;s type is decorated</span><br/><span class="hl-5">interface</span><span class="hl-1"> </span><span class="hl-6">X</span><span class="hl-1"> </span><span class="hl-5">extends</span><span class="hl-1"> </span><span class="hl-6">CreateDestroyStartStop</span><span class="hl-1"> {};</span><br/><span class="hl-1">@</span><span class="hl-7">CreateDestroyStartStop</span><span class="hl-1">(</span><span class="hl-5">new</span><span class="hl-1"> </span><span class="hl-7">Error</span><span class="hl-1">(</span><span class="hl-3">&#39;Running&#39;</span><span class="hl-1">), </span><span class="hl-5">new</span><span class="hl-1"> </span><span class="hl-7">Error</span><span class="hl-1">(</span><span class="hl-3">&#39;Destroyed&#39;</span><span class="hl-1">))</span><br/><span class="hl-5">class</span><span class="hl-1"> </span><span class="hl-6">X</span><span class="hl-1"> {</span><br/><span class="hl-1">  </span><span class="hl-5">protected</span><span class="hl-1"> </span><span class="hl-2">y</span><span class="hl-1">: </span><span class="hl-6">Y</span><span class="hl-1">;</span><br/><br/><span class="hl-1">  </span><span class="hl-5">public</span><span class="hl-1"> </span><span class="hl-5">static</span><span class="hl-1"> </span><span class="hl-5">async</span><span class="hl-1"> </span><span class="hl-7">createX</span><span class="hl-1">(</span><br/><span class="hl-1">    {</span><br/><span class="hl-1">      </span><span class="hl-2">y</span><br/><span class="hl-1">    }: {</span><br/><span class="hl-1">      </span><span class="hl-2">y</span><span class="hl-1">?: </span><span class="hl-6">Y</span><br/><span class="hl-1">    } = {}</span><br/><span class="hl-1">  ) {</span><br/><span class="hl-1">    </span><span class="hl-2">y</span><span class="hl-1"> = </span><span class="hl-2">y</span><span class="hl-1"> ?? </span><span class="hl-0">await</span><span class="hl-1"> </span><span class="hl-8">Y</span><span class="hl-1">.</span><span class="hl-7">createY</span><span class="hl-1">();</span><br/><span class="hl-1">    </span><span class="hl-5">const</span><span class="hl-1"> </span><span class="hl-8">x</span><span class="hl-1"> = </span><span class="hl-5">new</span><span class="hl-1"> </span><span class="hl-5">this</span><span class="hl-1">({ </span><span class="hl-2">y</span><span class="hl-1"> });</span><br/><span class="hl-1">    </span><span class="hl-0">await</span><span class="hl-1"> </span><span class="hl-2">x</span><span class="hl-1">.</span><span class="hl-7">start</span><span class="hl-1">();</span><br/><span class="hl-1">    </span><span class="hl-0">return</span><span class="hl-1"> </span><span class="hl-2">x</span><span class="hl-1">;</span><br/><span class="hl-1">  }</span><br/><br/><span class="hl-1">  </span><span class="hl-5">public</span><span class="hl-1"> </span><span class="hl-5">constructor</span><span class="hl-1"> ({ </span><span class="hl-2">y</span><span class="hl-1"> }: { </span><span class="hl-2">y</span><span class="hl-1">: </span><span class="hl-6">Y</span><span class="hl-1"> }) {</span><br/><span class="hl-1">    </span><span class="hl-5">this</span><span class="hl-1">.</span><span class="hl-2">y</span><span class="hl-1"> = </span><span class="hl-2">y</span><span class="hl-1">;</span><br/><span class="hl-1">  }</span><br/><br/><span class="hl-1">  </span><span class="hl-5">public</span><span class="hl-1"> </span><span class="hl-5">async</span><span class="hl-1"> </span><span class="hl-7">start</span><span class="hl-1">(): </span><span class="hl-6">Promise</span><span class="hl-1">&lt;</span><span class="hl-6">void</span><span class="hl-1">&gt; {</span><br/><span class="hl-1">    </span><span class="hl-0">await</span><span class="hl-1"> </span><span class="hl-5">this</span><span class="hl-1">.</span><span class="hl-2">y</span><span class="hl-1">.</span><span class="hl-7">start</span><span class="hl-1">();</span><br/><span class="hl-1">    </span><span class="hl-2">console</span><span class="hl-1">.</span><span class="hl-7">log</span><span class="hl-1">(</span><span class="hl-3">&#39;X started&#39;</span><span class="hl-1">);</span><br/><span class="hl-1">  }</span><br/><br/><span class="hl-1">  </span><span class="hl-5">public</span><span class="hl-1"> </span><span class="hl-5">async</span><span class="hl-1"> </span><span class="hl-7">stop</span><span class="hl-1">(): </span><span class="hl-6">Promise</span><span class="hl-1">&lt;</span><span class="hl-6">void</span><span class="hl-1">&gt; {</span><br/><span class="hl-1">    </span><span class="hl-0">await</span><span class="hl-1"> </span><span class="hl-5">this</span><span class="hl-1">.</span><span class="hl-2">y</span><span class="hl-1">.</span><span class="hl-7">stop</span><span class="hl-1">();</span><br/><span class="hl-1">    </span><span class="hl-2">console</span><span class="hl-1">.</span><span class="hl-7">log</span><span class="hl-1">(</span><span class="hl-3">&#39;X stopped&#39;</span><span class="hl-1">);</span><br/><span class="hl-1">  }</span><br/><br/><span class="hl-1">  </span><span class="hl-5">public</span><span class="hl-1"> </span><span class="hl-5">async</span><span class="hl-1"> </span><span class="hl-7">destroy</span><span class="hl-1">(): </span><span class="hl-6">Promise</span><span class="hl-1">&lt;</span><span class="hl-6">void</span><span class="hl-1">&gt; {</span><br/><span class="hl-1">    </span><span class="hl-0">await</span><span class="hl-1"> </span><span class="hl-5">this</span><span class="hl-1">.</span><span class="hl-2">y</span><span class="hl-1">.</span><span class="hl-7">destroy</span><span class="hl-1">();</span><br/><span class="hl-1">    </span><span class="hl-2">console</span><span class="hl-1">.</span><span class="hl-7">log</span><span class="hl-1">(</span><span class="hl-3">&#39;X destroyed&#39;</span><span class="hl-1">);</span><br/><span class="hl-1">  }</span><br/><br/><span class="hl-1">  @</span><span class="hl-7">ready</span><span class="hl-1">(</span><span class="hl-5">new</span><span class="hl-1"> </span><span class="hl-7">Error</span><span class="hl-1">(</span><span class="hl-3">&#39;Not Running&#39;</span><span class="hl-1">))</span><br/><span class="hl-1">  </span><span class="hl-5">public</span><span class="hl-1"> </span><span class="hl-5">async</span><span class="hl-1"> </span><span class="hl-7">doSomething</span><span class="hl-1">() {</span><br/><span class="hl-1">    </span><span class="hl-0">await</span><span class="hl-1"> </span><span class="hl-5">this</span><span class="hl-1">.</span><span class="hl-2">y</span><span class="hl-1">.</span><span class="hl-7">doSomething</span><span class="hl-1">();</span><br/><span class="hl-1">    </span><span class="hl-2">console</span><span class="hl-1">.</span><span class="hl-7">log</span><span class="hl-1">(</span><span class="hl-3">&#39;X did something&#39;</span><span class="hl-1">);</span><br/><span class="hl-1">  }</span><br/><span class="hl-1">}</span><br/><br/><span class="hl-4">// this hack is necessary to ensure that Y&#39;s type is decorated</span><br/><span class="hl-5">interface</span><span class="hl-1"> </span><span class="hl-6">Y</span><span class="hl-1"> </span><span class="hl-5">extends</span><span class="hl-1"> </span><span class="hl-6">CreateDestroyStartStop</span><span class="hl-1"> {};</span><br/><span class="hl-1">@</span><span class="hl-7">CreateDestroyStartStop</span><span class="hl-1">(</span><span class="hl-5">new</span><span class="hl-1"> </span><span class="hl-7">Error</span><span class="hl-1">(</span><span class="hl-3">&#39;Running&#39;</span><span class="hl-1">), </span><span class="hl-5">new</span><span class="hl-1"> </span><span class="hl-7">Error</span><span class="hl-1">(</span><span class="hl-3">&#39;Destroyed&#39;</span><span class="hl-1">))</span><br/><span class="hl-5">class</span><span class="hl-1"> </span><span class="hl-6">Y</span><span class="hl-1"> {</span><br/><span class="hl-1">  </span><span class="hl-5">public</span><span class="hl-1"> </span><span class="hl-5">static</span><span class="hl-1"> </span><span class="hl-5">async</span><span class="hl-1"> </span><span class="hl-7">createY</span><span class="hl-1">() {</span><br/><span class="hl-1">    </span><span class="hl-0">return</span><span class="hl-1"> </span><span class="hl-5">new</span><span class="hl-1"> </span><span class="hl-5">this</span><span class="hl-1">();</span><br/><span class="hl-1">  }</span><br/><br/><span class="hl-1">  </span><span class="hl-5">public</span><span class="hl-1"> </span><span class="hl-5">constructor</span><span class="hl-1"> () {</span><br/><span class="hl-1">  }</span><br/><br/><span class="hl-1">  </span><span class="hl-5">public</span><span class="hl-1"> </span><span class="hl-5">async</span><span class="hl-1"> </span><span class="hl-7">destroy</span><span class="hl-1">(): </span><span class="hl-6">Promise</span><span class="hl-1">&lt;</span><span class="hl-6">void</span><span class="hl-1">&gt; {</span><br/><span class="hl-1">    </span><span class="hl-2">console</span><span class="hl-1">.</span><span class="hl-7">log</span><span class="hl-1">(</span><span class="hl-3">&#39;Y destroyed&#39;</span><span class="hl-1">);</span><br/><span class="hl-1">  }</span><br/><br/><span class="hl-1">  @</span><span class="hl-7">ready</span><span class="hl-1">(</span><span class="hl-5">new</span><span class="hl-1"> </span><span class="hl-7">Error</span><span class="hl-1">(</span><span class="hl-3">&#39;Not Running&#39;</span><span class="hl-1">))</span><br/><span class="hl-1">  </span><span class="hl-5">public</span><span class="hl-1"> </span><span class="hl-5">async</span><span class="hl-1"> </span><span class="hl-7">doSomething</span><span class="hl-1">(): </span><span class="hl-6">Promise</span><span class="hl-1">&lt;</span><span class="hl-6">void</span><span class="hl-1">&gt; {</span><br/><span class="hl-1">    </span><span class="hl-2">console</span><span class="hl-1">.</span><span class="hl-7">log</span><span class="hl-1">(</span><span class="hl-3">&#39;Y did something&#39;</span><span class="hl-1">);</span><br/><span class="hl-1">  }</span><br/><span class="hl-1">}</span><br/><br/><span class="hl-5">async</span><span class="hl-1"> </span><span class="hl-5">function</span><span class="hl-1"> </span><span class="hl-7">main</span><span class="hl-1"> () {</span><br/><span class="hl-1">  </span><span class="hl-5">const</span><span class="hl-1"> </span><span class="hl-8">x</span><span class="hl-1"> = </span><span class="hl-0">await</span><span class="hl-1"> </span><span class="hl-8">X</span><span class="hl-1">.</span><span class="hl-7">createX</span><span class="hl-1">();</span><br/><span class="hl-1">  </span><span class="hl-0">await</span><span class="hl-1"> </span><span class="hl-2">x</span><span class="hl-1">.</span><span class="hl-7">doSomething</span><span class="hl-1">();</span><br/><span class="hl-1">  </span><span class="hl-0">await</span><span class="hl-1"> </span><span class="hl-2">x</span><span class="hl-1">.</span><span class="hl-7">stop</span><span class="hl-1">();</span><br/><span class="hl-1">  </span><span class="hl-0">await</span><span class="hl-1"> </span><span class="hl-2">x</span><span class="hl-1">.</span><span class="hl-7">destroy</span><span class="hl-1">();</span><br/><span class="hl-1">  </span><span class="hl-2">console</span><span class="hl-1">.</span><span class="hl-7">log</span><span class="hl-1">(</span><span class="hl-2">x</span><span class="hl-1">);</span><br/><span class="hl-1">}</span><br/><br/><span class="hl-7">main</span><span class="hl-1">();</span>
</code><button>Copy</button></pre>
<p>The <code>start</code>, <code>stop</code>, and <code>destroy</code> calls are all concurrent-controlled with <code>RWLockWriter</code>. They are idempotent and they are mutually exclusive between each other and any blocking <code>ready</code> decorated methods. Decorated methods can block <code>start</code>, <code>stop</code>, and <code>destroy</code>, but share a read lock between each other.</p>
<p>Refer to <a href="https://gist.github.com/CMCDragonkai/1dbf5069d9efc11585c27cc774271584">https://gist.github.com/CMCDragonkai/1dbf5069d9efc11585c27cc774271584</a> for further the motivation of this library.</p>
<a id="md:installation" class="tsd-anchor"></a><h2><a href="#md:installation">Installation</a></h2><pre><code class="language-sh"><span class="hl-7">npm</span><span class="hl-1"> </span><span class="hl-3">install</span><span class="hl-1"> </span><span class="hl-5">--save</span><span class="hl-1"> </span><span class="hl-3">@matrixai/async-init</span>
</code><button>Copy</button></pre>
<a id="md:development" class="tsd-anchor"></a><h2><a href="#md:development">Development</a></h2><p>Run <code>nix-shell</code>, and once you&#39;re inside, you can use:</p>
<pre><code class="language-sh"><span class="hl-4"># install (or reinstall packages from package.json)</span><br/><span class="hl-7">npm</span><span class="hl-1"> </span><span class="hl-3">install</span><br/><span class="hl-4"># build the dist</span><br/><span class="hl-7">npm</span><span class="hl-1"> </span><span class="hl-3">run</span><span class="hl-1"> </span><span class="hl-3">build</span><br/><span class="hl-4"># run the repl (this allows you to import from ./src)</span><br/><span class="hl-7">npm</span><span class="hl-1"> </span><span class="hl-3">run</span><span class="hl-1"> </span><span class="hl-3">tsx</span><br/><span class="hl-4"># run the tests</span><br/><span class="hl-7">npm</span><span class="hl-1"> </span><span class="hl-3">run</span><span class="hl-1"> </span><span class="hl-3">test</span><br/><span class="hl-4"># lint the source code</span><br/><span class="hl-7">npm</span><span class="hl-1"> </span><span class="hl-3">run</span><span class="hl-1"> </span><span class="hl-3">lint</span><br/><span class="hl-4"># automatically fix the source</span><br/><span class="hl-7">npm</span><span class="hl-1"> </span><span class="hl-3">run</span><span class="hl-1"> </span><span class="hl-3">lintfix</span>
</code><button>Copy</button></pre>
<a id="md:docs-generation" class="tsd-anchor"></a><h3><a href="#md:docs-generation">Docs Generation</a></h3><pre><code class="language-sh"><span class="hl-7">npm</span><span class="hl-1"> </span><span class="hl-3">run</span><span class="hl-1"> </span><span class="hl-3">docs</span>
</code><button>Copy</button></pre>
<p>See the docs at: <a href="https://matrixai.github.io/js-async-init/">https://matrixai.github.io/js-async-init/</a></p>
<a id="md:publishing" class="tsd-anchor"></a><h3><a href="#md:publishing">Publishing</a></h3><p>Publishing is handled automatically by the staging pipeline.</p>
<p>Prerelease:</p>
<pre><code class="language-sh"><span class="hl-4"># npm login</span><br/><span class="hl-7">npm</span><span class="hl-1"> </span><span class="hl-3">version</span><span class="hl-1"> </span><span class="hl-3">prepatch</span><span class="hl-1"> </span><span class="hl-5">--preid</span><span class="hl-1"> </span><span class="hl-3">alpha</span><span class="hl-1"> </span><span class="hl-4"># premajor/preminor/prepatch</span><br/><span class="hl-7">git</span><span class="hl-1"> </span><span class="hl-3">push</span><span class="hl-1"> </span><span class="hl-5">--follow-tags</span>
</code><button>Copy</button></pre>
<p>Release:</p>
<pre><code class="language-sh"><span class="hl-4"># npm login</span><br/><span class="hl-7">npm</span><span class="hl-1"> </span><span class="hl-3">version</span><span class="hl-1"> </span><span class="hl-3">patch</span><span class="hl-1"> </span><span class="hl-4"># major/minor/patch</span><br/><span class="hl-7">git</span><span class="hl-1"> </span><span class="hl-3">push</span><span class="hl-1"> </span><span class="hl-5">--follow-tags</span>
</code><button>Copy</button></pre>
<p>Manually:</p>
<pre><code class="language-sh"><span class="hl-4"># npm login</span><br/><span class="hl-7">npm</span><span class="hl-1"> </span><span class="hl-3">version</span><span class="hl-1"> </span><span class="hl-3">patch</span><span class="hl-1"> </span><span class="hl-4"># major/minor/patch</span><br/><span class="hl-7">npm</span><span class="hl-1"> </span><span class="hl-3">run</span><span class="hl-1"> </span><span class="hl-3">build</span><br/><span class="hl-7">npm</span><span class="hl-1"> </span><span class="hl-3">publish</span><span class="hl-1"> </span><span class="hl-5">--access</span><span class="hl-1"> </span><span class="hl-3">public</span><br/><span class="hl-7">git</span><span class="hl-1"> </span><span class="hl-3">push</span><br/><span class="hl-7">git</span><span class="hl-1"> </span><span class="hl-3">push</span><span class="hl-1"> </span><span class="hl-5">--tags</span>
</code><button>Copy</button></pre>
</div></div>
<div class="col-sidebar">
<div class="page-menu">
<div class="tsd-navigation settings">
<details class="tsd-index-accordion"><summary class="tsd-accordion-summary">
<h3><svg width="20" height="20" viewBox="0 0 24 24" fill="none"><path d="M4.93896 8.531L12 15.591L19.061 8.531L16.939 6.409L12 11.349L7.06098 6.409L4.93896 8.531Z" fill="var(--color-text)" id="icon-chevronDown"></path></svg>Settings</h3></summary>
<div class="tsd-accordion-details">
<div class="tsd-filter-visibility">
<h4 class="uppercase">Member Visibility</h4><form>
<ul id="tsd-filter-options">
<li class="tsd-filter-item"><label class="tsd-filter-input"><input type="checkbox" id="tsd-filter-protected" name="protected"/><svg width="32" height="32" viewBox="0 0 32 32" aria-hidden="true"><rect class="tsd-checkbox-background" width="30" height="30" x="1" y="1" rx="6" fill="none"></rect><path class="tsd-checkbox-checkmark" d="M8.35422 16.8214L13.2143 21.75L24.6458 10.25" stroke="none" stroke-width="3.5" stroke-linejoin="round" fill="none"></path></svg><span>Protected</span></label></li>
<li class="tsd-filter-item"><label class="tsd-filter-input"><input type="checkbox" id="tsd-filter-private" name="private"/><svg width="32" height="32" viewBox="0 0 32 32" aria-hidden="true"><rect class="tsd-checkbox-background" width="30" height="30" x="1" y="1" rx="6" fill="none"></rect><path class="tsd-checkbox-checkmark" d="M8.35422 16.8214L13.2143 21.75L24.6458 10.25" stroke="none" stroke-width="3.5" stroke-linejoin="round" fill="none"></path></svg><span>Private</span></label></li>
<li class="tsd-filter-item"><label class="tsd-filter-input"><input type="checkbox" id="tsd-filter-inherited" name="inherited" checked/><svg width="32" height="32" viewBox="0 0 32 32" aria-hidden="true"><rect class="tsd-checkbox-background" width="30" height="30" x="1" y="1" rx="6" fill="none"></rect><path class="tsd-checkbox-checkmark" d="M8.35422 16.8214L13.2143 21.75L24.6458 10.25" stroke="none" stroke-width="3.5" stroke-linejoin="round" fill="none"></path></svg><span>Inherited</span></label></li>
<li class="tsd-filter-item"><label class="tsd-filter-input"><input type="checkbox" id="tsd-filter-external" name="external"/><svg width="32" height="32" viewBox="0 0 32 32" aria-hidden="true"><rect class="tsd-checkbox-background" width="30" height="30" x="1" y="1" rx="6" fill="none"></rect><path class="tsd-checkbox-checkmark" d="M8.35422 16.8214L13.2143 21.75L24.6458 10.25" stroke="none" stroke-width="3.5" stroke-linejoin="round" fill="none"></path></svg><span>External</span></label></li></ul></form></div>
<div class="tsd-theme-toggle">
<h4 class="uppercase">Theme</h4><select id="tsd-theme"><option value="os">OS</option><option value="light">Light</option><option value="dark">Dark</option></select></div></div></details></div>
<details open class="tsd-index-accordion tsd-page-navigation"><summary class="tsd-accordion-summary">
<h3><svg width="20" height="20" viewBox="0 0 24 24" fill="none"><use href="#icon-chevronDown"></use></svg>On This Page</h3></summary>
<div class="tsd-accordion-details">
<ul>
<li>
<ul>
<li><a href="#md:js-async-init"><span>js-<wbr/>async-<wbr/>init</span></a></li>
<li>
<ul>
<li><a href="#md:installation"><span>Installation</span></a></li>
<li><a href="#md:development"><span>Development</span></a></li>
<li>
<ul>
<li><a href="#md:docs-generation"><span>Docs <wbr/>Generation</span></a></li>
<li><a href="#md:publishing"><span>Publishing</span></a></li></ul></li></ul></li></ul></li></ul></div></details></div>
<div class="site-menu">
<nav class="tsd-navigation"><a href="modules.html" class="current"><svg class="tsd-kind-icon" viewBox="0 0 24 24"><g id="icon-4"><rect fill="var(--color-icon-background)" stroke="var(--color-ts-namespace)" stroke-width="1.5" x="1" y="1" width="22" height="22" rx="6"></rect><path d="M9.33 16V7.24H10.77L13.446 14.74C13.43 14.54 13.41 14.296 13.386 14.008C13.37 13.712 13.354 13.404 13.338 13.084C13.33 12.756 13.326 12.448 13.326 12.16V7.24H14.37V16H12.93L10.266 8.5C10.282 8.692 10.298 8.936 10.314 9.232C10.33 9.52 10.342 9.828 10.35 10.156C10.366 10.476 10.374 10.784 10.374 11.08V16H9.33Z" fill="var(--color-text)"></path></g></svg><span>@matrixai/async-<wbr/>init</span></a>
<ul class="tsd-small-nested-navigation">
<li><a href="modules.html#destroyed"><svg class="tsd-kind-icon" viewBox="0 0 24 24"><g id="icon-8388608"><rect fill="var(--color-icon-background)" stroke="#FF4D82" stroke-width="1.5" x="1" y="1" width="22" height="22" rx="12"></rect><path d="M10.354 17V8.24H13.066C13.586 8.24 14.042 8.348 14.434 8.564C14.826 8.772 15.13 9.064 15.346 9.44C15.562 9.816 15.67 10.256 15.67 10.76C15.67 11.352 15.514 11.86 15.202 12.284C14.898 12.708 14.482 13 13.954 13.16L15.79 17H14.518L12.838 13.28H11.434V17H10.354ZM11.434 12.308H13.066C13.514 12.308 13.874 12.168 14.146 11.888C14.418 11.6 14.554 11.224 14.554 10.76C14.554 10.288 14.418 9.912 14.146 9.632C13.874 9.352 13.514 9.212 13.066 9.212H11.434V12.308Z" fill="var(--color-text)"></path></g></svg><span>destroyed</span></a></li>
<li><a href="modules.html#initLock"><svg class="tsd-kind-icon" viewBox="0 0 24 24"><use href="#icon-8388608"></use></svg><span>init<wbr/>Lock</span></a></li>
<li><a href="modules.html#running"><svg class="tsd-kind-icon" viewBox="0 0 24 24"><use href="#icon-8388608"></use></svg><span>running</span></a></li>
<li><a href="modules.html#status"><svg class="tsd-kind-icon" viewBox="0 0 24 24"><use href="#icon-8388608"></use></svg><span>status</span></a></li>
<li><a href="modules.html#statusP"><svg class="tsd-kind-icon" viewBox="0 0 24 24"><use href="#icon-8388608"></use></svg><span>statusP</span></a></li>
<li><a href="modules/createDestroy.html"><svg class="tsd-kind-icon" viewBox="0 0 24 24"><use href="#icon-4"></use></svg><span>create<wbr/>Destroy</span></a></li>
<li><a href="modules/createDestroyStartStop.html"><svg class="tsd-kind-icon" viewBox="0 0 24 24"><use href="#icon-4"></use></svg><span>create<wbr/>Destroy<wbr/>Start<wbr/>Stop</span></a></li>
<li><a href="modules/errors.html"><svg class="tsd-kind-icon" viewBox="0 0 24 24"><use href="#icon-4"></use></svg><span>errors</span></a></li>
<li><a href="modules/events.html"><svg class="tsd-kind-icon" viewBox="0 0 24 24"><use href="#icon-4"></use></svg><span>events</span></a></li>
<li><a href="modules/startStop.html"><svg class="tsd-kind-icon" viewBox="0 0 24 24"><use href="#icon-4"></use></svg><span>start<wbr/>Stop</span></a></li>
<li><a href="modules/types.html"><svg class="tsd-kind-icon" viewBox="0 0 24 24"><use href="#icon-4"></use></svg><span>types</span></a></li></ul></nav></div></div></div>
<div class="tsd-generator">
<p>Generated using <a href="https://typedoc.org/" target="_blank">TypeDoc</a></p></div>
<div class="overlay"></div></body></html>